package polyglot.ext.atomjava.ast;

import polyglot.ext.atomjava.types.AtomJavaContext;
import polyglot.ext.atomjava.types.AtomJavaTypeSystem;
import polyglot.ext.atomjava.visit.*;
import polyglot.ext.atomjava.util.AJS;
import polyglot.ext.jl.ast.MethodDecl_c;
import polyglot.ast.*;
import polyglot.util.*;
import polyglot.types.*;
import polyglot.visit.*;

import java.util.*;

public class AtomJavaAtomicMethodDecl_c 
  extends AJAbstractMethodDecl {

  public AtomJavaAtomicMethodDecl_c(Position pos, Flags flags, 
                                    TypeNode returnType, String name, 
                                    List formals, List throwTypes, Block body) 
  {
    super(pos, flags, returnType, name, formals, throwTypes, body);
  }
  
  //// this version of the method is always in an atomic scope
  public Context enterScope(Context c) {
    c = super.enterScope(c);
    c = ((AtomJavaContext)c).pushAtomic();
    return c;
  }

  public Node build(Node parent, AtomJavaBuilder ab) {
    AtomJavaContext c = ab.context();
    AtomJavaNodeFactory nf = ab.nodeFactory();
    AtomJavaTypeSystem ts = ab.typeSystem();

    if(flags.isNative()) {
      String errmsg = c.currentClass().fullName() + "." + name;
      List args = AJS.List(nf.StringLit(c, errmsg));
      CanonicalTypeNode ctn = 
        nf.CanonicalTypeNode(c,ts.AtomJavaNativeInAtomicError());
      New n = nf.New(c, null, ctn, args, null);
      Throw t = nf.Throw(c, n);
      MethodDecl md = (MethodDecl) body(nf.Block(c, AJS.List(t)));
      md = md.flags(flags.clearNative());
      MethodInstance mi = md.methodInstance();
      mi = mi.flags(md.flags());
      md = md.methodInstance(mi);
      return md;
    }

    return convertSynchronized(c, nf, ts);
  }
  
}

