package polyglot.ext.atomjava.runtime;

final public class AArray {
  static public <T> T get_T(T[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }
  static public <T> T get_T(AThread me, T[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }
  static public boolean get_boolean(boolean[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public boolean get_boolean(AThread me, boolean[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public byte get_byte(byte[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public byte get_byte(AThread me,byte[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public char get_char(char[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public char get_char(AThread me,char[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public short get_short(short[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public short get_short(AThread me,short[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public int get_int(int[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public int get_int(AThread me,int[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public long get_long(long[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }        
  static public long get_long(AThread me,long[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }        
  static public float get_float(float[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }    
  static public float get_float(AThread me,float[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }    
  static public double get_double(double[] a, int i) {
    AThread.acq_arraylk(a);
    return a[i];
  }
  static public double get_double(AThread me,double[] a, int i) {
    AThread.acq_arraylk(me,a);
    return a[i];
  }
    
  static public <T> T set_T(T[] a, int i, T v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }
  static public boolean set_boolean(boolean[] a, int i, boolean v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }
  static public byte set_byte(byte[] a, int i, byte v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }
  static public char set_char(char[] a, int i, char v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }    
  static public short set_short(short[] a, int i, short v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }    
  static public int set_int(int[] a, int i, int v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }    
  static public long set_long(long[] a, int i, long v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }        
  static public float set_float(float[] a, int i, float v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }    
  static public double set_double(double[] a, int i, double v) {
    AThread.acq_arraylk(a);
    return a[i] = v;
  }

  static public <T> T set_atomic_T(T[] a, int i, T v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }
  static public boolean set_atomic_boolean(boolean[] a, int i, boolean v){
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, (a[i] ? 1 : 0));
    return a[i] = v;
  }    
  static public byte set_atomic_byte(byte[] a, int i, byte v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }    
  static public char set_atomic_char(char[] a, int i, char v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }    
  static public short set_atomic_short(short[] a, int i, short v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }    
  static public int set_atomic_int(int[] a, int i, int v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }    
  static public long set_atomic_long(long[] a, int i, long v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }        
  static public float set_atomic_float(float[] a, int i, float v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }
  static public double set_atomic_double(double[] a, int i, double v) {
    AThread.acq_arraylk(a);
    AThread.currentThread().log(a, i, a[i]);
    return a[i] = v;
  }

  static public <T> T[] clone(T[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public boolean[] clone(boolean[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public byte[] clone(byte[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public char[] clone(char[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public short[] clone(short[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public int[] clone(int[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public long[] clone(long[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public float[] clone(float[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public double[] clone(double[] array) {
    AThread.acq_arraylk(array);
    return array.clone();
  }
  static public <T> T[] __aj_clone(T[] array) {
    return clone(array);
  }
  static public boolean[] __aj_atomic_clone(boolean[] array) {
    return clone(array);
  }
  static public byte[] __aj_atomic_clone(byte[] array) {
    return clone(array);
  }
  static public char[] __aj_atomic_clone(char[] array) {
    return clone(array);
  }
  static public short[] __aj_atomic_clone(short[] array) {
    return clone(array);
  }
  static public int[] __aj_atomic_clone(int[] array) {
    return clone(array);
  }
  static public long[] __aj_atomic_clone(long[] array) {
    return clone(array);
  }
  static public float[] __aj_atomic_clone(float[] array) {
    return clone(array);
  }
  static public double[] __aj_atomic_clone(double[] array) {
    return clone(array);
  }

}
