package polyglot.ext.atomjava.types;

import polyglot.ast.*;
import polyglot.types.*;
import java.util.*;

import polyglot.ext.atomjava.visit.*;

public interface AtomJavaContext extends Context {
  public List getLocalVars();
  public List getLocalVars(List locals);
  public Context pushTryCatch();
  public boolean inTryCatchContext();
  public Context pushAtomicBlock();
  public Context pushAtomic();
  public Context ignoreAtomic();
  public boolean inAtomicContext();
  public boolean inAtomicBlock();
  public String atomicMethodName(String orig);
  public String fieldSetterName(String field);
  public String fieldGetterName(String field);
  public String fieldUndoerName(String field);
  public String atomicFormalName();
  public String atomicConstructorFieldName();
  public String arrayElementGetterName(Type type);
  public String arrayElementSetterName(Type type);
  public MethodDecl makeArrayOperatorMethod(Type array_type, 
                                            Assign.Operator assop,
                                            AtomJavaBuilder ab);
  public MethodDecl makeFieldOperatorMethod(Field field, 
                                            Assign.Operator assop,
                                            AtomJavaBuilder ab);
  public MethodDecl makeThrowingFailureMethod(Call call, List throwTypes,
                                              AtomJavaBuilder ab);
}
