package polyglot.ext.atomjava.types;

import polyglot.types.*;

public interface AtomJavaTypeSystem extends TypeSystem {  

  public static final String RUNTIME = 
    "polyglot.ext.atomjava.runtime.";

  public ClassType NoSuchMethodError();
  public ClassType Failure();
  public ClassType Thread(); 
  public ClassType runtime_java_lang_Object();
  public ClassType AThread();
  public ClassType AObject();
  public ClassType AArray();
  public ClassType AMain();
  public ClassType AtomJavaNativeInAtomicError();
  public ClassType AtomJavaUnreachableCodeError();
  public ClassType AtomJavaRollBack();
  public ClassType undoerType(Type t);
  public Type undoValueType(Type t);
  public ClassType AConstructorFormal();
  public ClassType NewWithFinalizerInAtomic();
  public Type updateType(Type t);
  public void addTypeUpdate(ClassType from, ClassType to);
  public void addTypeUpdate(ClassType t);
  public MethodInstance updateMethodInstance(MethodInstance mi);
  public ConstructorInstance updateConstructorInstance(ConstructorInstance ci);
  public LocalInstance updateLocalInstance(LocalInstance li);
  public FieldInstance updateFieldInstance(FieldInstance fi);
  public InitializerInstance updateInitializerInstance(InitializerInstance ii);
  public boolean useWrappers(ClassType t);
}
