package polyglot.ext.atomjava.util;

import polyglot.util.Position;
import polyglot.main.Report;
import java.util.*;

/**
 * Thrown during any number of phases of the compiler during which 
 * the atomjava runtime system does not support an atomic call.
 */
public class UnsupportedRuntimeException extends RuntimeException {
  protected Position position;
  
  public UnsupportedRuntimeException(String m, Position position) {
    super(m);
    this.position = position;
    trace(this, 5);
  }
  
  public Position position() {
    return position;
  }
  
  static void trace(Exception e, int level) {
    if (Report.should_report(Report.errors, level)) {
      e.printStackTrace();
    }
  }
}
