package polyglot.ext.atomjava.visit;

import polyglot.ext.atomjava.ast.*;

import polyglot.visit.*;
import polyglot.ast.*;
import polyglot.frontend.*;
import polyglot.types.*;
import polyglot.util.*;

import java.util.*;

/**
 * Inside an atomic block we need to save all of the local variables in case
 * we rollback we can reset the local variables too. However, we can't just
 * save all of the local variables because some of them might not actually be
 * initialized. This replacement for the default init checker just constructs
 * a list of those things that are initialized. That way, when we go to build
 * atomic blocks (in ast/AtomicBlock_c.java) we only save those variables that
 * have been initialized.
 */

public class AJInitChecker extends InitChecker {
  public AJInitChecker(Job job, TypeSystem ts, NodeFactory nf) {
    super(job, ts, nf);
  }

//   public void check(FlowGraph graph, Term n, Item inItem, Map outItems) 
//     throws SemanticException {

//     if (!(n instanceof AtomicBlock.AtomicBlockEntry)) {
//       super.check(graph, n, inItem, outItems);
//       return;
//     }
    
//     DataFlowItem dfIn = (DataFlowItem)inItem;
//     if (dfIn == null)
// 	dfIn = createInitDFI();
    
//     DataFlowItem dfOut = null;
//     if (outItems != null && !outItems.isEmpty())
//       dfOut = (DataFlowItem)outItems.values().iterator().next(); 

//     List uninitialized = new LinkedList();

//     for(Iterator i = currCBI.localDeclarations.iterator(); i.hasNext();) {
//       LocalInstance li = (LocalInstance)i.next();
//       Local pseudo_local = 
//         nodeFactory().Local(Position.COMPILER_GENERATED, li.name());
//       pseudo_local = (Local) pseudo_local.localInstance(li).type(li.type());
//       pseudo_local = (Local) pseudo_local.reachable(true);
//       try { checkLocal(graph, pseudo_local, dfIn, dfOut); }
//       catch (SemanticException e) { uninitialized.add(li); }
//     }
    
//     ((AtomicBlock.AtomicBlockEntry)n).uninitializedDecls(uninitialized);
//   }
}
