package polyglot.ext.atomjava.visit;

import polyglot.visit.NodeVisitor;
import polyglot.ast.*;
import polyglot.ext.atomjava.ast.*;
import polyglot.util.InternalCompilerError;
import java.util.LinkedList;

// DO ME: use a flow-analysis to remove more method release-calls
// Note: assuming constructor calls cannot be cyclic
public class ReleaseCheckInserter extends NodeVisitor {
  AtomJavaNodeFactory nf;
  boolean hasCall = false;
  ReleaseCheckInserter inner;
  public ReleaseCheckInserter(NodeFactory nf) {
    super();
    this.hasCall = false;
    this.nf = (AtomJavaNodeFactory)nf;
  }
  public NodeVisitor enter(Node n) {
    if(n instanceof MethodDecl) // b/c of hasCall and nested methods
      return inner = new ReleaseCheckInserter(nf); 
    return this;
  }

  public Node leave(Node old, Node n, NodeVisitor v) {
    if(n instanceof MethodDecl) {
      if(!inner.hasCall)
        return n;
      MethodDecl m = (MethodDecl)n;
      LinkedList new_stmts = new LinkedList(m.body().statements());
      new_stmts.addFirst(nf.ReleaseMaybeCheck());
      return m.body(m.body().statements(new_stmts));
    } else if(n instanceof Loop) {
      Loop loop = (Loop)n;
      LinkedList new_stmts = new LinkedList();
      new_stmts.add(nf.ReleaseMaybeCheck());
      new_stmts.add(loop.body());
      Block new_body = nf.Block(polyglot.util.Position.COMPILER_GENERATED, new_stmts);
      if(loop instanceof While) return ((While)loop).body(new_body);
      if(loop instanceof For)   return ((For)loop).body(new_body);
      if(loop instanceof Do)    return ((Do)loop).body(new_body);
      throw new InternalCompilerError("unexpected loop form");
    } else if(n instanceof Call) {
      hasCall = true;
    }
    return n;
  }
}
